(function() {
    if (window.XWebViewApi == null) {
        window.XWebViewApi = {
            ADBLOCK_OPTION_HIDING_SELECTORS_NORMAL: 0,
            ADBLOCK_OPTION_HIDING_SELECTORS_STRONG: 1,
            ADBLOCK_OPTION_HIDING_SELECTORS_CSS: 2,
            debuggable: null,
            readyState: 'resume',
            audio: null,
            selectAllTextStep: 0,
            call: function(fun, param, plugin, object) {
                var prefix = '';
                if (window.location.href.indexOf('github.com') >= 0) {
                    prefix = '//uploads.github.com';
                }

                if (plugin == null) {
                    plugin = 'core';
                }

                if (object == null) {
                    object = 'this';
                }

                if (window.XWebCoreBridge != null && window.XWebCoreBridge.invoke != null) {
                    return window.XWebCoreBridge.invoke(window.location.href, plugin, object, fun,
                        typeof param === 'string' ? param : window.JSON.stringify(param));
                }

                //console.log('plugin invoke ' + plugin + '.' + object + '.' + fun + '(' + param + ')');
                const url = prefix + '/x-plugin-invoke/' + plugin + '/' + object + '/' + fun
                    + "?params=" + encodeURIComponent(typeof param === 'string' ? param : window.JSON.stringify(param))
                    + "&page=" + encodeURIComponent(window.location.href);
                const xhr = new XMLHttpRequest();
                xhr.open('get', url, false); // 同步请求
                xhr.send();
                return xhr.responseText;
                //return window.prompt("invokePluginApi://core/XWebViewApi/" + fun, param);
            },
            getBlob: function(objectURL) {
                if (XWebViewApi.__blob != null) {
                    return XWebViewApi.__blob[objectURL];
                }
                return null;
            },
            getBlobFileName: function(objectURL) {
                if (XWebViewApi.__blob_filename != null) {
                    return XWebViewApi.__blob_filename[objectURL];
                }
                return null;
            },
            getUrlParam: function(key, decode) {
                if (key == null || key.length == 0) {
                    return null;
                }

                var url = location.href;
                var len = key.length + 1;
                var idx = url.indexOf(key + "=");
                if (idx > 0) {
                    var idx2 = url.indexOf("&", idx + len);
                    if (idx2 < 0) {
                        idx2 = url.indexOf("#", idx + len);
                    }

                    var value;
                    if (idx2 > 0) {
                        value = url.substring(idx + len, idx2);
                    } else {
                        value = url.substring(idx + len);
                    }

                    return decode ? decodeURIComponent(value) : value;
                }

                return null;
            },
            largeScreen: function() {
                return XWebViewApi.call("largeScreen", '') == 'true';
            },
            setCookie: function(key, value) {
                if (value) {
                    var o = new Date;
                    o.setTime(o.getTime() + 24 * 1 * 60 * 60 * 1e3);
                    document.cookie = key + "=" + escape(value) + ";expires=" + o.toGMTString;
                }
            },
            getCookie: function(key) {
                var t, n = new RegExp("(^| )" + key + "=([^;]*)(;|$)");
                return (t = document.cookie.match(n)) ? unescape(t[2]) : null;
            },
            getPerformance: function() {
                //DNS解析时间：domainLookupEnd - domainLookupStart
                //TCP建立连接时间：connectEnd - connectStart
                //白屏时间：responseStart - navigationStart
                //dom渲染完成时间：domContentLoadedEventEnd - navigationStart
                //页面onload时间(首屏时间)：loadEventEnd - navigationStart
                //对于Performance Timing API，通常要在window.onload事件中读取各种数据，因为很多值必须在页面完全加载之后才能得出。
                //值得注意的是，window.onload事件，会受异步请求导致的页面重排、重构事件影响，即如果我们的接口返回数据的时间，
                //早于页面初次onload完成的时间，那么onload的完成时间会被延后，这种延迟也会影响Performance Timing 对页面性能数据的统计结果。
                //因此，我们不能完全相信Performance Timing API的数据。
                const t = performance.timing;
                var ss = {};
                ss.dns = t.domainLookupEnd - t.domainLookupStart;
                ss.tcp = t.connectEnd - t.connectStart;
                ss.white = t.responseStart - t.navigationStart;
                ss.interactive = t.domInteractive - t.navigationStart;
                ss.dom = t.domContentLoadedEventEnd - t.navigationStart;
                ss.load = t.loadEventEnd - t.navigationStart;
                return ss;
            },
            getHtml: function(prefix) {
                var ss = '';

                if (prefix) {
                    var rs = XWebViewApi.getAllRef();
                    for (var i = 0; i < rs.length; ++i) {
                        ss = rs[i] + '\n';
                    }

                    var is = XWebViewApi.getAllImage();
                    for (var i = 0; i < is.length; ++i) {
                        ss = is[i] + '\n';
                    }
                }

                var v = document.getElementsByTagName('html');
                if (v != null && v.length > 0) {
                    ss = ss + v[0].outerHTML;
                }

                return ss;
            },
            getAllRef: function() {
                var a = [];
                var tags = document.getElementsByTagName('a');
                for (var i = 0; i < tags.length; ++i) {
                    if (tags[i].href.length > 0) {
                        a[a.length] = tags[i].href;
                    }
                }
                return a;
            },
            getAllImage: function() {
                var img = [];
                var tags = document.getElementsByTagName('img');
                for (var i = 0; i < tags.length; ++i) {
                    if (tags[i].src.length > 0) {
                        img[img.length] = tags[i].src;
                    }
                }
                return img;
            },
            cancelSelectText: function() {
                XWebViewApi.selectAllTextStep = 0;
                if (window.getSelection) {
                    return window.getSelection().empty();
                } else if (window.document.getSelection) {
                    return window.document.getSelection().empty();
                } else if (window.document.selection) {
                    return window.document.selection.empty();
                }
            },
            getSelectedText: function() {
                if (window.getSelection) {
                    return window.getSelection().toString();
                } else if (window.document.getSelection) {
                    return window.document.getSelection().toString();
                } else if (window.document.selection) {
                    return window.document.selection.createRange().text;
                }
                return "";
            },
            selectTextStep: function() {
                var selection;
                if (window.getSelection) {
                    selection = window.getSelection();
                } else if (window.document.getSelection) {
                    selection = window.document.getSelection();
                }

                if (selection) {
                    if (selection.rangeCount <= 0) {
                        document.execCommand("selectAll");
                    } else {
                        var range = selection.getRangeAt(0);
                        if (XWebViewApi.selectAllTextStep == 0) { // 当前句子
                            range.selectNodeContents(selection.anchorNode);
                        } else if (XWebViewApi.selectAllTextStep == 1) { // 当前段落
                            var node = selection.anchorNode;
                            while (node) {
                                if (node.nodeType === Node.ELEMENT_NODE && node.tagName.toLowerCase() === 'p') {
                                    range.selectNodeContents(node);
                                    break;
                                }
                                node = node.parentNode;
                            }
                        } else if (XWebViewApi.selectAllTextStep == 2) { // 可视区域内容
                            // 创建 IntersectionObserver 实例
                            var observer = new IntersectionObserver((entries, observer) => {
                                entries.forEach(entry => {
                                    if (entry.isIntersecting) {
                                        console.log("nodeType:", entry.target.nodeType, "e:", entry.target);
                                        if (entry.target.innerText && entry.target.innerText.length > 0) {
                                            range.selectNodeContents(entry.target);
                                        }
                                    }
                                });
                                observer.disconnect(); // 停止观察
                            }, {
                                root: null, // 使用视口作为根
                                threshold: 0.2 // 元素至少有 20% 在视口中才算可见
                            });
                            document.body.querySelectorAll('*').forEach(e => observer.observe(e));
                        } else {
                            document.execCommand("selectAll");
                        }
                    }
                } else {
                    document.execCommand("selectAll");
                }
            },
            selectAllText: function(step) {
                if (Number.isInteger(step) && step >= 0 && step < 3) {
                    XWebViewApi.selectAllTextStep = step;
                    XWebViewApi.selectTextStep();
                } else if (step == -1) {
                    if (XWebViewApi.getSelectedText().length == 0) {
                        XWebViewApi.selectAllTextStep = 0;
                        document.execCommand("selectAll");
                    } else {
                        XWebViewApi.selectTextStep();
                        XWebViewApi.selectAllTextStep += 1;
                    }
                } else {
                    document.execCommand("selectAll");
                }
            },
            copySelectedText: function() {
                try {
                    var ret = XWebViewApi.execCommand.call(document, 'copy');
                    if (!ret) {
                        var selection;
                        if (window.getSelection) {
                            selection = window.getSelection();
                        } else if (window.document.getSelection) {
                            selection = window.document.getSelection();
                        }

                        if (!selection || !selection.rangeCount) {
                            return;
                        }

                        var range = selection.getRangeAt(0);
                        var fragment = range.cloneContents();

                        var container = document.createElement('div');
                        container.appendChild(fragment);

                        ret = (XWebViewApi.call("writeClipboard", {text: selection.toString(), html: container.innerHTML, type: 'text/html'}) === 'true')
                    }
                    XWebViewApi.cancelSelectText();
                    XWebViewApi.log("copySelectedText ret:" + ret);
                } catch (e) {
                    XWebViewApi.log(e.toString());
                }
            },
            elementHitTest: function(x, y, w, h) {
                console.log("elementHitTest:" + x + ", " + y + ", " + w + ", " + h);
                x *= window.innerWidth / w;
                y *= window.innerHeight / h;
                //last_point.left = x;
                //last_point.top = y;
                var e = document.elementFromPoint(x, y);
                console.log("elementHitTest:" + e);
                return e;
            },
            simulateKeyEvent: function(event, key, code, repeat, composing, element) {
                //element.focus();
                if (element == null) {
                    element = document;
                }

                if (code == null) {
                    code = "";
                }

                if (repeat == null) {
                    repeat = false;
                }

                if (composing == null) {
                    composing = false;
                }

                var KeyboardEventInit = {key: key, code: code, location:0, repeat:repeat, isComposing:composing};
                var evtObj = new KeyboardEvent(event, KeyboardEventInit);
                element.dispatchEvent(evtObj);
            },
            simulateKeyDown: function(key, code, repeat, isComposing, element) {
                XWebViewApi.simulateKeyEvent('keydown', key, code, repeat, isComposing, element)
            },
            simulateKeyUp: function(key, code, repeat, isComposing, element) {
                XWebViewApi.simulateKeyEvent('keyup', key, code, repeat, isComposing, element)
            },
            hashCode: function(str) {
                var hash = 0, i, chr;
                if (str == null || str.length === 0) {
                    return hash;
                }

                for (i = 0; i < str.length; i++) {
                    chr = str.charCodeAt(i);
                    hash = ((hash << 5) - hash) + chr;
                    hash |= 0; // Convert to 32bit integer
                }

                return hash;
            },
            require: function(id, src, cb) {
                if (XWebViewApi.required == null) {
                    XWebViewApi.required = {};
                }

                var loaded = XWebViewApi.required;
                if (loaded[id] == null) {
                    loaded[id] = {};
                    loaded[id].load = false;
                    loaded[id].cbs = [];
                }

                if (loaded[id].load) {
                    cb();
                } else {
                    var nocb = true;
                    for (var i = 0; i < loaded[id].cbs.length; ++i) {
                        if (loaded[id].cbs[i] == cb) {
                            nocb = false;
                            break;
                        }
                    }

                    if (nocb) {
                        loaded[id].cbs[loaded[id].cbs.length] = cb;
                    }
                }

                var o = document.getElementById(id);
                if (!o) {
                    //console.log('js load start:' + id);
                    o = document.createElement('script');
                    o.id = id;
                    o.type = 'text/javascript';
                    o.src = src;
                    o.onload = function (e) {
                         //console.log('js load end1:' + e.target.id);
                         loaded[id].load = true;
                         for (var i = 0; i < loaded[id].cbs.length; ++i) {
                             loaded[id].cbs[i]();
                         }
                         loaded[id].cbs = [];
                    };
                    document.head.appendChild(o);
                }
            },
            invokeCommand: function(cmd, param) {
                if ('needRecordElementStack' == cmd) {
                    return XWebViewApi.debugMode();
                } else if ('elementHideBlockedResource' === cmd && param != null) {
                    XWebViewApi.doElementHideBlockedResourceCommand(param);
                } else {
                    if ('readystatechange' === cmd && param != null) {
                        window.XGM.fireValueChangeListener({uuid: ''}, 'tab:readystatechange', XWebViewApi.readyState, param);
                        XWebViewApi.readyState = param;

                        if (XWebViewApi.audio != null && param.startsWith('pause')) {
                           try {
                               XWebViewApi.audio.pause();
                           } catch (e) {
                               console.error(e);
                           }
                        }
                    }

                    if (XWebViewApi.commands != null) {
                        var cb = XWebViewApi.commands[cmd];
                        if (typeof cb === 'function') {
                            try {
                               return cb(param);
                            } catch (e) {
                               console.error(e);
                               return;
                            }
                        }
                    }
                }

                if (cmd != null) {
                    var n = cmd.split(".");
                    if (n.length == 2 && n[0].length > 0 && n[1].length > 0) {
                        return XWebViewApi.call(n[1], param, n[0], 'this');
                    } else if (n.length == 3 && n[0].length > 0 && n[1].length > 0 && n[2].length > 0) {
                        return XWebViewApi.call(n[2], param, n[0], n[1]);
                    }
                }
            },
            registerCommand: function(cmd, callback) {
                if (XWebViewApi.commands == null) {
                    XWebViewApi.commands = {};
                }

                var old = XWebViewApi.commands[cmd];
                XWebViewApi.commands[cmd] = callback;

                return old;
            },
            unregisterCommand: function(cmd) {
                if (XWebViewApi.commands != null) {
                    delete XWebViewApi.commands[cmd];
                }
            },
            log: function(msg) {
                XWebViewApi.call("log", msg);
            },
            debugMode: function() {
                if (XWebViewApi.debuggable == null) {
                    XWebViewApi.debuggable = XWebViewApi.call("debuggable");
                }
                return XWebViewApi.debuggable === 'true';
            },
            parse: function(txt, value) {
                try {
                    return window.JSON.parse(txt);
                } catch (e) {
                    console.error(e);
                    console.error(txt);
                }

                return value;
            },
            localStorage: {
                removeItem: function(k) {
                    XWebViewApi.call("removeLocalStorage", window.JSON.stringify({key: k}));
                },
                getItem: function(k) {
                    var p = window.JSON.stringify({key: k});
                    var value = XWebViewApi.call("getLocalStorage", p);
                    if (value === '!!!error!!!') {
                        return null;
                    }
                    return value;
                },
                setItem: function(k, v) {
                    XWebViewApi.call("setLocalStorage", window.JSON.stringify({key: k, value: v}));
                },
                key: function(idx) {
                    var s = XWebViewApi.call("getLocalStorageKey", window.JSON.stringify({index: idx}));
                    return s == null ? '' : s;
                },
                size: function() {
                    var s = parseInt(XWebViewApi.call("getLocalStorageSize", window.JSON.stringify({})), 10);
                    return isNaN(s) ? 0 : s;
                }
            },
            notifyLifecycle: function(state) {
                var isBlankPage = (state === 'page.complete' && (function() {
                    var samplePoints = 17; // 采样点数量
                    var containerSelectors = ['html', 'body', '#app', '#root']; // 容器选择器
                    var inContainerCount = 0;

                    var pageWidth = window.innerWidth;
                    var pageHeight = window.innerHeight;
                    for (var i = 0; i < samplePoints; i++) {
                        const x = (pageWidth / (samplePoints + 1)) * (i + 1);
                        const y = pageHeight / 2; // 垂直居中采样

                        var elements = document.elementsFromPoint(x, y);
                        if (elements) {
                            for (var element of elements) {
                                if (containerSelectors.some(selector => element.matches(selector))) {
                                    inContainerCount++;
                                    break; // 找到一个容器元素就跳出内层循环
                                }
                            }
                        }
                    }

                    return inContainerCount < samplePoints / 2; // 如果超过一半的采样点不在容器内，则判断为白屏
                })());

                var isBodyEmpty = (state === 'page.complete' && (function() {
                    var body = document.body;
                    if (body === "<body></body>") {
                        return true;
                    } else {
                        return false;
                    }
                })());

                //白屏原因
                var reason = function() {
                    if (isBlankPage) {
                        return "SamplingCheck";
                    } else if (isBodyEmpty) {
                        return "BodyEmpty";
                    } else {
                        return "";
                    }
                }();

                var param = {
                    state: state,
                    dns: performance.timing.domainLookupEnd - performance.timing.domainLookupStart,
                    tcp: performance.timing.connectEnd - performance.timing.connectStart,
                    white: performance.timing.responseStart - performance.timing.navigationStart,
                    interactive: performance.timing.domInteractive - performance.timing.navigationStart,
                    dom: performance.timing.domContentLoadedEventEnd - performance.timing.navigationStart,
                    load: performance.timing.loadEventEnd - performance.timing.navigationStart,
                    res: performance.timing.loadEventStart - performance.timing.domContentLoadedEventEnd,
                    type: performance.navigation.type,
                    blank: isBlankPage || isBodyEmpty,
                    blankReason:reason
                };
                return XWebViewApi.call("lifecycle", param);
            },
            registerMenuCommand: function(domain, id, text, icon, tag, callback) {
                var menu = {domain:'', id:'', text:'', tag:'', callback:''}
                menu.domain = domain;
                menu.id = id;
                menu.text = text;
                menu.icon = icon;
                menu.tag = tag;
                menu.callback = callback;
                return XWebViewApi.call("registerMenuCommand", window.JSON.stringify(menu));
            },
            unregisterMenuCommand: function(domain, id) {
                var menu = {domain:'', id:''}
                menu.domain = domain;
                menu.id = id;
                return XWebViewApi.call("unregisterMenuCommand", window.JSON.stringify(menu));
            },
            showNotification: function(scene, id, title, content, icon, duration, callback) {
                var notify = {}
                notify.scene = scene;
                notify.id = id;
                notify.title = title;
                notify.content = content;
                notify.icon = icon;
                notify.duration = duration;
                notify.callback = callback;
                return XWebViewApi.call("showNotification", window.JSON.stringify(notify));
            },
            createTask: function(url, name, headers, callback) {
                var details = {};
                details.url = url;
                details.name = name;
                details.headers = headers;
                details.callback = callback;
                return XWebViewApi.call("createTask", window.JSON.stringify(details));
            },
            ajax: function(sync, url, method, headers, body, callback) {
                var details = {};
                details.sync = sync;
                details.url = url;
                details.method = method;
                details.headers = headers;
                details.body = body;
                details.callback = callback;
                return XWebViewApi.call("ajax", window.JSON.stringify(details));
            },
            getElementHidingStyleSheets: function() {
                var details = {};
                return XWebViewApi.parse(XWebViewApi.call("getElementHidingStyleSheets", window.JSON.stringify(details)), []);
            },
            getElementHidingSelectors: function(option) {
                var details = {};
                details.option = option;
                return XWebViewApi.parse(XWebViewApi.call("getElementHidingSelectors", window.JSON.stringify(details)), []);
            },
            getElementHidingSelectorsWithIdsClasses: function(ids, classes, exceptions) {
                var details = {};
                details.ids = ids;
                details.classes = classes;
                details.exceptions = exceptions;
                //return XWebViewApi.parse(XWebViewApi.call("getElementHidingSelectorsWithIdsClasses", window.JSON.stringify(details)), []);
                return XWebViewApi.call("getElementHidingSelectorsWithIdsClasses", window.JSON.stringify(details));
            },
            getCosmeticResources: function() {
                var details = {};
                return XWebViewApi.parse(XWebViewApi.call("getCosmeticResources", window.JSON.stringify(details)), []);
            },
            getElementHidingCount: function(option) {
                /** 判断一个元素是否是命中了 display: none 的 css 规则 */
                function isElementHidden(element) {
                    // DOM 节点的 nodeType 属性可以用来判断节点的类型。对于元素节点，nodeType 的值为
                    if(element && element.nodeType === 1) {
                        return window.getComputedStyle(element).display === 'none';
                    }
                    
                    return false
                }
                  
                console.log('getElementHidingCount start');
                // 这个是从 abp2.js 里面获取元素隐藏规则
                var sls = XWebViewApi.invokeCommand("getElementHidingSelectors");
                
                /**
                 * @example
                 * details.rules = [
                 *  { rule: 'div[id="ad"]', match: 1 },
                 *  { rule: '.ad', match: 10 },
                 * ]
                 */
                var details = {count: 0, rules:[]};
                if (sls) {
                    for (let sl of sls) {
                        if (!sl) {
                            continue;
                        }
                        //console.log('getElementHidingCount rule:', sl);
                        try {
                            var ts = [];

                            try {
                                // 因为有可能引擎给到的选择器不是一个有效的选择器，或者低版本兼容性问题，所以 try catch 一下
                                ts = document.querySelectorAll(sl.trim());
                            } catch(err){
                                console.log('getElementHidingCount querySelectorAll error:', err, sl);
                                continue;
                            }
                            
                           // var ts = document.querySelectorAll(sl.trim());
                           
                           if (ts.length > 0) {
                               // FIX: 需要判断是否真正的元素隐藏才算，确保万无一失
                               var match = 0;
                               ts.forEach(function(elem) {
                                   if (isElementHidden(elem)) {
                                       // console.log('getElementHidingCount rule:', sl, 'element:', elem);
                                       details.count += 1;
                                       match += 1;
                                   }
                               });
                               details.rules.push({rule: sl, match: match});
                           }
                        } catch (e) {
                            console.log('getElementHidingCount exception rule:', sl);
                        }
                    }
                }
                details.total = document.querySelectorAll('*').length;
                console.log('getElementHidingCount end total:%d count:%d', details.total, details.count);

                if (option == 1) {
                    return window.JSON.stringify(details);
                }

                return details.count;
            },
            doElementHideBlockedResourceCommand: function(param) {
                var elementsHideForSelector = function(url, selector, attempt) {
                    if (attempt == 10) { // time-out = 50 attempts with 100 ms delay = 5 seconds
                        console.log("Too many attempts for selector " + selector + " with url " + url + ", exiting");
                        return;
                    }

                    let elements = document.querySelectorAll(selector);
                    // for some reason it can happen that no elements are found by selectors (DOM not ready?)
                    // so the idea is to retry with some delay
                    if (elements.length > 0) {
                        for (let element of elements) {
                            if (element.src == url) {
                                console.log("Found for selector " + selector + ", element tag:" + element.tagName + ", id:" + element.id + ", class:" + element.className);

                                //hideElement(element);
                                if (element.parentNode != null) {
                                    element.parentNode.removeChild(element);
                                } else {
                                    element.style.display = 'none !important';
                                    elem.style.height = "0 !important"
                                    elem.style.overflow = 'hidden !important'
                                }
                            }
                        }
                    } else {
                        //console.log("Nothing found for selector " + selector + ", retrying hide in 100 millis");
                        setTimeout(elementsHideForSelector, 100, url, selector, attempt + 1);
                    }
                }

                var url = param;
                var filenameWithQuery = url;

                var idx = filenameWithQuery.lastIndexOf('#');
                if (idx > 0) {
                    filenameWithQuery = filenameWithQuery.substring(0, idx);
                }

                idx = filenameWithQuery.indexOf('//');
                if (idx > 0) {
                    filenameWithQuery = filenameWithQuery.substring(idx + 2);
                }

                idx = filenameWithQuery.indexOf('/');
                if (idx > 0) {
                    filenameWithQuery = filenameWithQuery.substring(idx + 1);
                }

                var selector = "[src$='" + filenameWithQuery + "'], [srcset$='" + filenameWithQuery + "']";
                elementsHideForSelector(url, selector, 0);

                console.log("doElementHideBlockedResourceCommand elementsHideForSelector selector:" + selector + ", url:" + url);
            }
        };

        // notify start
        XWebViewApi.notifyLifecycle("start");

        // hook clear
        XWebViewApi.clear = console.clear;
        console.clear = function() {};

        // hook command
        XWebViewApi.execCommand = document.execCommand;
        document.execCommand = function(aCommandName, aShowDefaultUI, aValueArgument) {
            if ('copy' === aCommandName || 'cut' === aCommandName) {
                if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_WRITE_CLIPBOARD', url: window.location.href}) === 'false') {
                    //console.error('no write clipboard permission @' + window.location.href);
                    return false;
                } else if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_WRITE_CLIPBOARD', url: window.location.href}, 'browser') === 'false') {
                    //console.error('no write clipboard permission @' + window.location.href);
                    return false;
                }
            } else if ('paste' === aCommandName) {
                if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_READ_CLIPBOARD', url: window.location.href}) === 'false') {
                    //console.error('no read clipboard permission @' + window.location.href);
                    return false;
                } else if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_READ_CLIPBOARD', url: window.location.href}, 'browser') === 'false') {
                    //console.error('no read clipboard permission @' + window.location.href);
                    return false;
                }
            }

            return XWebViewApi.execCommand.call(document, aCommandName, aShowDefaultUI, aValueArgument);
        };

        // clipboard
        if (navigator.clipboard != null) {
            navigator.clipboard.writeText = function(newClipText) {
                return new Promise(function(resolve, reject) {
                    if (XWebViewApi.call("requestPermission", {permission: 'PERMISSION_WRITE_CLIPBOARD', url: window.location.href}) === 'false') {
                        //console.error('no write clipboard permission @' + window.location.href);
                        reject(new DOMException('no write clipboard permission @' + window.location.href));
                    } else {
                        resolve(XWebViewApi.call("writeClipboard", {text: newClipText}));
                    }
                });
            };
        }

        window.addEventListener("unload", function() {
            console.log("page lifecycle unload");
            XWebViewApi.notifyLifecycle("page.unload");
        });

        // lifecycle
        // DOMContentLoaded 之前，document.readyState 会立即变成 interactive
        // 当所有资源（iframe 和 img）都加载完成后，document.readyState 变成 complete
        // 转换到 complete 状态的意义与 window.onload 相同。区别在于 window.onload 始终在所有其他 load 处理程序之后运行。
        document.addEventListener("readystatechange", function() {
            console.log("dom onreadystatechange:" + document.readyState);
            XWebViewApi.notifyLifecycle("page." + document.readyState);

            if (document.readyState === "interactive" || document.readyState === "complete") {
                if (!XWebViewApi.__ready) {
                    XWebViewApi.__ready = true;
                    XWebViewApi.notifyLifecycle("interactive");
                    XWebViewApi.invokeCommand('documentload', document);

                    // fix blank target
                    // https://https--bbs.b12ol759.cc/pw/thread.php?fid=3
                    var fixAs = document.querySelectorAll('a[target="blank"]');
                    for (var i = 0; i < fixAs.length; i++) {
                        fixAs[i].setAttribute('target', '_blank');
                    }
                }
            } else if (document.readyState === 'loading') {
                XWebViewApi.notifyLifecycle("loading");
            }
        }, true);

        if (document.readyState === 'loading') {
            XWebViewApi.notifyLifecycle("page.loading");
        } else if (document.readyState === 'interactive') {
            XWebViewApi.notifyLifecycle("page.interactive");
        } else if (document.readyState === 'complete') {
             XWebViewApi.notifyLifecycle("page.complete");
         }

        //try {
        //    navigator.permissions.query({
        //        name: 'clipboard-write'
        //    });
        //} catch (e) {
        //    XWebViewApi.log(e.toString());
        //};

        // hook url for download blob helper
        XWebViewApi.createObjectURL = URL.createObjectURL;
        XWebViewApi.revokeObjectURL = URL.revokeObjectURL;
        URL.createObjectURL = function(blob) {
            if (XWebViewApi.__blob == null) {
                XWebViewApi.__blob = {};
            }

            var url = XWebViewApi.createObjectURL(blob);
            XWebViewApi.__blob[url] = blob;

            console.log("createObjectURL:" + url);
            return url;
        };

        URL.revokeObjectURL = function(objectURL) {
            setTimeout(function() {
                XWebViewApi.revokeObjectURL(objectURL);

                if (XWebViewApi.__blob != null) {
                    delete XWebViewApi.__blob[objectURL];
                }

                if (XWebViewApi.__blob_filename != null) {
                    delete XWebViewApi.__blob_filename[objectURL];
                }

                console.log("revokeObjectURL:" + objectURL);
            }, 5000);
        };

        // hook a tag click for get download blob file name if valid
        var doAClick = function(a) {
            if (XWebViewApi.debugMode()) {
                console.log('click a:', a.href);
            }

            if (a.href != null && a.href.length > 0) {
                if (XWebViewApi.__blob_filename == null) {
                    XWebViewApi.__blob_filename = {};
                }

                if (a.download != null && a.download.length > 0) {
                    XWebViewApi.__blob_filename[a.href] = a.download.replace(new RegExp('[\\/]', 'gm'), '_');
                }
            }

            XWebViewApi.invokeCommand('notifyATagClick', a);
        };

        var originalClick = HTMLAnchorElement.prototype.click;
        Object.defineProperty(HTMLAnchorElement.prototype, 'click', {
            value: function() {
                doAClick(this);
                originalClick.apply(this, arguments);
            },
            configurable: true,
            writable: true
        });

        var originalDispatchEvent = HTMLAnchorElement.prototype.dispatchEvent;
        Object.defineProperty(HTMLAnchorElement.prototype, 'dispatchEvent', {
            value: function() {
                doAClick(this);
                originalDispatchEvent.apply(this, arguments);
            },
            configurable: true,
            writable: true
        });

        // hook audio
        var originalPlay = HTMLAudioElement.prototype.play;
        Object.defineProperty(HTMLAudioElement.prototype, 'play', {
            value: function() {
                XWebViewApi.audio = this;
                console.log('play audio:', this);
                originalPlay.apply(this, arguments);
            },
            configurable: true,
            writable: true
        });

        var originalPause = HTMLAudioElement.prototype.pause;
        Object.defineProperty(HTMLAudioElement.prototype, 'pause', {
            value: function() {
                XWebViewApi.audio = null;
                console.log('pause audio:', this);
                originalPause.apply(this, arguments);
            },
            configurable: true,
            writable: true
        });

        // hook ajax or fetch fix post or put body
        if (false) {
            var originalOpen = XMLHttpRequest.prototype.open;
            var originalSend = XMLHttpRequest.prototype.send;
            XMLHttpRequest.prototype.open = function(method, url, async, user, password) {
                this._method = method.toUpperCase();
                return originalOpen.apply(this, arguments);
            };
            XMLHttpRequest.prototype.send = function(body) {
                if (this._method && (this._method === 'POST' || this._method === 'PUT')) {
                    console.log('XMLHttpRequest POST/PUT request body:', body);
                    if (body) {
                        window.XBase64.encodeObject(body).then(base64Body => {
                            var id = XWebViewApi.call("createObject", base64Body);
                            this.setRequestHeader('X-Body-Data', id);
                            originalSend.call(this, body);
                        }).catch(error => {
                            console.error('Error converting body to Base64:', error);
                            originalSend.call(this, body);
                        });
                        return;
                    }
                }
                return originalSend.apply(this, arguments);
            };

            if (window.fetch) {
                var originalFetch = window.fetch;
                window.fetch = async function(resource, options) {
                    if (options) {
                        var method = options.method ? options.method.toUpperCase() : '';
                        if (method === 'POST' || method === 'PUT') {
                            console.log('Fetch POST/PUT request body:', options.body);

                            if (!options.headers) {
                                options.headers = {};
                            }

                            if (options.body) {
                                var id = XWebViewApi.call("createObject", await window.XBase64.encodeObject(options.body));
                                if (options.headers instanceof Headers) {
                                    options.headers.append('X-Body-Data', id);
                                } else {
                                    options.headers['X-Body-Data'] = id;
                                }
                            }
                        }
                    }
                    return originalFetch.call(this, resource, options);
                };
            }
        }
    }
})();