(function() {
    // page compat: force scalable
    var disableScale = 'disable' === XWebViewApi.getUrlParam('x-scale');
    if (!disableScale && window.navigator != null && window.navigator.userAgent != null && document.head != null) {
        var largeScreen = XWebViewApi.largeScreen();
        var pc = !largeScreen && (window.navigator.userAgent.indexOf('Macintosh') >= 0 || window.navigator.userAgent.indexOf('Windows') >= 0);
        var xlApp = document.querySelector('meta[name=x-app-page]');
        if (!xlApp) {
            var meta = document.querySelector('meta[name=viewport]');
            if (meta != null) {
                var c = meta.getAttribute('content');
                if (c != null) {
                    var newContent = '';
                    var cs = c.split(',');
                    if (cs != null && cs.length > 0) {
                        var hasInit = false;
                        var hasMax = false;
                        var hasMini = false;
                        var hasScale = false;
                        for (var i = 0; i < cs.length; ++i) {
                            var item = cs[i];
                            if (item.indexOf('minimum-scale') >= 0) {
                                newContent += "minimum-scale=0.1, ";
                                hasMini = true;
                            } else if (item.indexOf('maximum-scale') >= 0) {
                                newContent += "maximum-scale=10, ";
                                hasMax = true;
                            } else if (item.indexOf('user-scalable') >= 0) {
                                newContent += "user-scalable=yes, ";
                                hasScale = true;
                            } else {
                                if (pc) {
                                    if (item.indexOf('initial-scale') >= 0) {
                                        newContent += "initial-scale=0.1, ";
                                        hasInit = true;
                                    } else if (item.indexOf('width') < 0) {
                                        newContent += item.trim() + ", ";
                                    }
                                } else {
                                    newContent += item.trim() + ", ";
                                    hasInit = true;
                                }
                            }
                        }

                        if (!hasInit) {
                            newContent += "initial-scale=0.1, ";
                        }
                        if (!hasMini) {
                            newContent += "minimum-scale=0.1, ";
                        }
                        if (!hasMax) {
                            newContent += "maximum-scale=10, ";
                        }
                        if (!hasScale) {
                            newContent += "user-scalable=yes, ";
                        }

                        if (newContent.endsWith(', ')) {
                            newContent = newContent.substring(0, newContent.length - 2);
                        }

                        if (newContent.length == 0) {
                            if (pc) {
                                newContent = 'initial-scale=0.1, minimum-scale=0.1, maximum-scale=10, user-scalable=yes';
                            } else {
                                newContent = 'minimum-scale=0.1, maximum-scale=10, user-scalable=yes';
                            }
                        }

                        meta.setAttribute('content', newContent);
                    }
                }
            } else {
                var meta = document.createElement('meta');
                meta.setAttribute('name', 'viewport');
                if (pc) {
                    meta.setAttribute('content', 'initial-scale=0.1, minimum-scale=0.1, maximum-scale=10, user-scalable=yes');
                } else {
                    meta.setAttribute('content', 'minimum-scale=0.1, maximum-scale=10, user-scalable=yes');
                }
                document.head.appendChild(meta);
            }
        }
    }
})();